TeachTxtParser Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
TeachTxtParser Class Reference

the main class to read a SimpleText/TeachText/Tex-Edit file More...

`#include <TeachTxtParser.hxx>`

Inheritance diagram for TeachTxtParser:

## Public Member Functions
| TeachTxtParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~TeachTxtParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
void | newPage (int number)
| adds a new page More...
bool | createZones ()
| finds the different objects zones More...
bool | readStyles (MWAWEntry const &entry)
| try to read the styles ( resource styl : SimpleText,id=128, Tex-Edit,id=1000 ) More...
bool | readWRCT (MWAWEntry const &entry)
| try to read the unknown wrct structure ( only in TexEdit,id=1000 ) More...
int | computeNumPages () const
| compute the number of page of a zone More...
bool | sendText ()
| try to send the main text More...
bool | sendPicture (int id)
| try to send a picture knowing the id More...
void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< TeachTxtParserInternal::State > | m_state
| the state More...

## Friends
class | TTText

## Detailed Description

the main class to read a SimpleText/TeachText/Tex-Edit file

## Constructor & Destructor Documentation

TeachTxtParser::TeachTxtParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

TeachTxtParser::~TeachTxtParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

bool TeachTxtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

    visibly, some other applications can create ttxt file,

so check that we have at least a styl rsrc or a PICT

Implements MWAWParser.

Referenced by parse().

int TeachTxtParser::computeNumPages | ( |  | ) | const
| protected

compute the number of page of a zone

Referenced by createDocument().

void TeachTxtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

bool TeachTxtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

checkme: find also two times BBSR:0x250 with size 0x168, probably not in the format..

Referenced by parse().

void TeachTxtParser::flushExtra | ( |  | ) |
| protected

sends the data which have not yet been sent to the listener

Referenced by parse().

void TeachTxtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by TeachTxtParser().

void TeachTxtParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendText().

void TeachTxtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWTextParser.

bool TeachTxtParser::readStyles | ( | MWAWEntry const & | entry | ) |
| protected

try to read the styles ( resource styl : SimpleText,id=128, Tex-Edit,id=1000 )

Referenced by createZones().

bool TeachTxtParser::readWRCT | ( | MWAWEntry const & | entry | ) |
| protected

try to read the unknown wrct structure ( only in TexEdit,id=1000 )

Referenced by createZones().

libmwaw::DebugFile & TeachTxtParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readStyles(), and readWRCT().

MWAWInputStreamPtr TeachTxtParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by readStyles(), readWRCT(), and sendPicture().

bool TeachTxtParser::sendPicture | ( | int | id | ) |
| protected

try to send a picture knowing the id

Referenced by flushExtra(), and sendText().

bool TeachTxtParser::sendText | ( |  | ) |
| protected

try to send the main text

Referenced by parse().

## Friends And Related Function Documentation

friend class TTText
| friend

## Member Data Documentation

shared_ptr<TeachTxtParserInternal::State> TeachTxtParser::m_state
| protected

the state

Referenced by checkHeader(), computeNumPages(), createDocument(), createZones(), flushExtra(), init(), newPage(), readStyles(), sendPicture(), and sendText().

The documentation for this class was generated from the following files:

- TeachTxtParser.hxx
- TeachTxtParser.cxx